#include <stdio.h>
#include "gpiotimer.h"
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>


void init_sockaddr(struct sockaddr_in *name, const char *hostname, unsigned short int port)
{
    struct hostent *hostinfo;

    name->sin_family = AF_INET;
    name->sin_port = htons(port);
    hostinfo = gethostbyname(hostname);
    if (hostinfo == NULL) {
        fprintf(stderr, "Unknown host %s.\n", hostname);
        exit(EXIT_FAILURE);
    }
    name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
}

int main()
{
    //printf("Content-type: text/plain\n\n");
    printf("Content-type: application/json\n\n");


    struct GpiotimerData data;

    int sock;
    struct sockaddr_in servername;

    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
        perror("socket (client)");
        exit(EXIT_FAILURE);
    }

    init_sockaddr(&servername, "localhost", 3000);

    if (0 > connect(sock, (struct sockaddr *) &servername, sizeof(servername))) {
        perror("connect (client)");
        exit(EXIT_FAILURE);
    }

    if (read(sock, &data, sizeof(data)) != sizeof(data)) {
        close(sock);
        exit(EXIT_FAILURE);
    }

    // Print data in JSON-Format
    printf("{\n");
    printf("  \"time\": %d,\n", data.dtime_all);
    printf("  \"counter\": %d,\n", data.counter);
    printf("  \"last_W\": %f\n", data.last_W);
    printf("}\n");

    close(sock);

    return 0;
}
