#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
//#include "i2c-dev.h"

void sendcmd(int file, unsigned short cmd)
{
  unsigned char buf[2];
  buf[0]=0x80;
  buf[1]=cmd;
     
  if ( write(file,buf,2) != 2) {
    /* ERROR HANDLING: i2c transaction failed */
    printf("Write error\n");
  }
}

int main(int argc, char* argv[])
{
  int file;
  int adapter_nr = 1; /* probably dynamically determined */
  char filename[20];
  
  sprintf(filename,"/dev/i2c-%d",adapter_nr);
  if ((file = open(filename,O_RDWR)) < 0) {
    /* ERROR HANDLING; you can check errno to see what went wrong */
    printf("error\n");
    exit(1);
  }

  /*When you have opened the device, you must specify with what device
  address you want to communicate:*/
  int addr = 0x3c; /* The I2C address */
  if (ioctl(file,0x0703/*I2C_SLAVE*/,addr) < 0) {
    /* ERROR HANDLING; you can check errno to see what went wrong */
    printf("error\n");
    exit(1);
  }

  sendcmd(file,0xae); // off
  sendcmd(file,0xa1); // seg re-map
  sendcmd(file,0xaf); // on
  return 0;
}
