#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
//#include "i2c-dev.h"
#include "font_6x8.h"

void sendcmd(int file, unsigned short cmd)
{
  unsigned char buf[2];
  buf[0]=0x80;
  buf[1]=cmd;
     
  if ( write(file,buf,2) != 2) {
    /* ERROR HANDLING: i2c transaction failed */
    printf("Write error\n");
  }
}

void sendchar(int file, unsigned char c)
{
  unsigned char buf[6+1]={0x40, 0x00};
  unsigned char *data = Font_6x8[c];

  int row,col;
  for(row=0;row<8;row++)
  for(col=0;col<6;col++)
  {
     if(data[row] & (1<<(5-col)))
     {
       buf[col+1] |= (1<<row);
     }
  }

  if ( write(file,buf,sizeof(buf)) != sizeof(buf)) {
    /* ERROR HANDLING: i2c transaction failed */
    printf("Write error\n");
  }
  //sleep(1);
}

int main(int argc, char* argv[])
{
  int file;
  int adapter_nr = 1; /* probably dynamically determined */
  char filename[20];
  
  sprintf(filename,"/dev/i2c-%d",adapter_nr);
  if ((file = open(filename,O_RDWR)) < 0) {
    /* ERROR HANDLING; you can check errno to see what went wrong */
    printf("error\n");
    exit(1);
  }

  /*When you have opened the device, you must specify with what device
  address you want to communicate:*/
  int addr = 0x3c; /* The I2C address */
  if (ioctl(file,0x0703/*I2C_SLAVE*/,addr) < 0) {
    /* ERROR HANDLING; you can check errno to see what went wrong */
    printf("error\n");
    exit(1);
  }

  // Set the page start address of the target display location by command B0h to B4h.
  sendcmd(file,0xb1);
  // Set the lower start column address of pointer by command 00h~0Fh.
  sendcmd(file,0x00);
  // Set the upper start column address of pointer by command 10h~17h.
  sendcmd(file,0x10);

  if(argc<2)
  {
    printf("no text\n");
    return 0;
  }

  char *text = argv[1];

  int i=0;
  while(i < 32)
  {
    char c = *text;
    if(c=='\0')
    {
      c=' ';
    }
    else text++;
    
    sendchar(file,c);
    
    i++;
    if(i==16)
    {
      sendcmd(file,0xb2);
      sendcmd(file,0x00);
      sendcmd(file,0x10);
    }
  }

  return 0;
}
